const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Ai_agentsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const ai_agents = await db.ai_agents.create(
      {
        id: data.id || undefined,

        name: data.name || null,
        version: data.version || null,
        accuracy_pct: data.accuracy_pct || null,
        latency_ms: data.latency_ms || null,
        status: data.status || null,
        last_updated: data.last_updated || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await ai_agents.setOrganization(currentUser.organization.id || null, {
      transaction,
    });

    await ai_agents.setOrganizations(data.organizations || null, {
      transaction,
    });

    return ai_agents;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const ai_agentsData = data.map((item, index) => ({
      id: item.id || undefined,

      name: item.name || null,
      version: item.version || null,
      accuracy_pct: item.accuracy_pct || null,
      latency_ms: item.latency_ms || null,
      status: item.status || null,
      last_updated: item.last_updated || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const ai_agents = await db.ai_agents.bulkCreate(ai_agentsData, {
      transaction,
    });

    // For each item created, replace relation files

    return ai_agents;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const ai_agents = await db.ai_agents.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.name !== undefined) updatePayload.name = data.name;

    if (data.version !== undefined) updatePayload.version = data.version;

    if (data.accuracy_pct !== undefined)
      updatePayload.accuracy_pct = data.accuracy_pct;

    if (data.latency_ms !== undefined)
      updatePayload.latency_ms = data.latency_ms;

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.last_updated !== undefined)
      updatePayload.last_updated = data.last_updated;

    updatePayload.updatedById = currentUser.id;

    await ai_agents.update(updatePayload, { transaction });

    if (data.organization !== undefined) {
      await ai_agents.setOrganization(
        globalAccess ? data.organization : currentUser.organization.id,
        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await ai_agents.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return ai_agents;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const ai_agents = await db.ai_agents.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of ai_agents) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of ai_agents) {
        await record.destroy({ transaction });
      }
    });

    return ai_agents;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const ai_agents = await db.ai_agents.findByPk(id, options);

    await ai_agents.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await ai_agents.destroy({
      transaction,
    });

    return ai_agents;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const ai_agents = await db.ai_agents.findOne({ where }, { transaction });

    if (!ai_agents) {
      return ai_agents;
    }

    const output = ai_agents.get({ plain: true });

    output.organization = await ai_agents.getOrganization({
      transaction,
    });

    output.organizations = await ai_agents.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organization',
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('ai_agents', 'name', filter.name),
        };
      }

      if (filter.version) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('ai_agents', 'version', filter.version),
        };
      }

      if (filter.accuracy_pctRange) {
        const [start, end] = filter.accuracy_pctRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            accuracy_pct: {
              ...where.accuracy_pct,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            accuracy_pct: {
              ...where.accuracy_pct,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.latency_msRange) {
        const [start, end] = filter.latency_msRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            latency_ms: {
              ...where.latency_ms,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            latency_ms: {
              ...where.latency_ms,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.last_updatedRange) {
        const [start, end] = filter.last_updatedRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            last_updated: {
              ...where.last_updated,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            last_updated: {
              ...where.last_updated,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organization) {
        const listItems = filter.organization.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationId: { [Op.or]: listItems },
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.ai_agents.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('ai_agents', 'name', query),
        ],
      };
    }

    const records = await db.ai_agents.findAll({
      attributes: ['id', 'name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.name,
    }));
  }
};
